local mod = ...

mod:registerBehaviorTreeNode({
    Name = "BEHAVIOR_NODE_SECURITY_CONSUME",
    VariableList = {
		Var1 = "BEHAVIOR_TREE_DATA_AGENT",
		Var2 = "BEHAVIOR_TREE_DATA_WAIT",
    },
    Init = function(self, instance)
		mod:log("INIT!")
    end,
    Update = function(self, level, instance)
		mod:log("UPDATE!")
		return self:updateFunc(level, instance)
    end,
    Finish = function(self, instance)
		mod:log("FINISH!")
    end,
	updateFunc = function(self, level, instance)
		mod:log("UPDATE FUNC!")
		mod:log("Agent data: " .. tostring(self.Var1))
		mod:log(tostring(self.Var1.Agent))
		mod:log("Agent data owner: " .. tostring(self.Var1.Agent:getOwner()))
		return BEHAVIOR_TREE_NODE_RESULT.TRUE
	end,
})

mod:registerBehaviorTree({
	Id = "BEHAVIOR_TREE_SECURITY_CONSUME",
	VariableList = {
		{
			Name = "AgentData",
			DataType = "BEHAVIOR_TREE_DATA_AGENT",
			IsPublic = true,
			InitialValue = {} -- Optional if empty, leaves the default values (if any)
		},
		{
			Name = "DoWait",
			DataType = "BEHAVIOR_TREE_DATA_WAIT",
			IsPublic = false,
			InitialValue = {
				TimeToWait = 10,
				Animation = AGENT_ANIMATION.IDLE,
				SetIdleAfterWait = false,
			}
		},
	},
	Root = {
		Name = "WorkingGlobalSequencer",
		Type = "SEQUENCER",
		Children = {
			{
				Name = "BEHAVIOR_NODE_INSTANCE_SECURITY_CONSUME",
				Type = "BEHAVIOR_NODE_SECURITY_CONSUME",
				Var1 = "AgentData",
				Var2 = "DoWait",
			},
			{
				Name = "WaitWhileConsuming",
				Type = "WAIT",
				AgentData = "AgentData",
				TimeToWait = "DoWait",
			},
		}
	}
})